VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "USB-IIRO4-2SM"
   ClientHeight    =   1785
   ClientLeft      =   5985
   ClientTop       =   6270
   ClientWidth     =   4725
   LinkTopic       =   "Form1"
   ScaleHeight     =   1785
   ScaleWidth      =   4725
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2160
      Top             =   1080
   End
   Begin VB.Image inputImage 
      Height          =   375
      Index           =   3
      Left            =   2760
      Top             =   480
      Width           =   375
   End
   Begin VB.Image inputImage 
      Height          =   375
      Index           =   2
      Left            =   3120
      Top             =   480
      Width           =   375
   End
   Begin VB.Image inputImage 
      Height          =   375
      Index           =   1
      Left            =   3480
      Top             =   480
      Width           =   375
   End
   Begin VB.Image inputImage 
      Height          =   375
      Index           =   0
      Left            =   3840
      Top             =   480
      Width           =   375
   End
   Begin VB.Label Label2 
      Caption         =   "Inputs"
      Height          =   255
      Left            =   3240
      TabIndex        =   1
      Top             =   120
      Width           =   615
   End
   Begin VB.Image relayImage 
      Height          =   375
      Index           =   3
      Left            =   120
      Top             =   480
      Width           =   375
   End
   Begin VB.Image relayImage 
      Height          =   375
      Index           =   2
      Left            =   480
      Top             =   480
      Width           =   375
   End
   Begin VB.Image relayImage 
      Height          =   375
      Index           =   1
      Left            =   840
      Top             =   480
      Width           =   375
   End
   Begin VB.Image relayImage 
      Height          =   375
      Index           =   0
      Left            =   1200
      Top             =   480
      Width           =   375
   End
   Begin VB.Label Label1 
      Caption         =   "Relays"
      Height          =   255
      Left            =   480
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
   Begin VB.Image lowImage 
      Height          =   360
      Left            =   1560
      Picture         =   "Form1.frx":0000
      Top             =   1080
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Image highImage 
      Height          =   360
      Left            =   1080
      Picture         =   "Form1.frx":06E2
      Top             =   1080
      Visible         =   0   'False
      Width           =   375
   End
   Begin VB.Image closedImage 
      Height          =   360
      Left            =   600
      Picture         =   "Form1.frx":0DC4
      Top             =   1080
      Visible         =   0   'False
      Width           =   360
   End
   Begin VB.Image openImage 
      Height          =   360
      Left            =   120
      Picture         =   "Form1.frx":1446
      Top             =   1080
      Visible         =   0   'False
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Dim DeviceIndex As Long
Dim update As Boolean
'Dim lastIndex As Integer
Dim outData As Integer
Private OnBits(0 To 31) As Long


Private Sub Form_Load()

    Dim PID As Long
    Dim NameSize As Long
    Dim Name As String
    Dim DIOBytes As Long
    Dim Counters As Long
    Dim count As Integer
    Dim Status As Long

        
    DeviceIndex = diFirst
    
    Status = QueryDeviceInfo(DeviceIndex, PID, NameSize, Name, DIOBytes, Counters)
    
    If (Status <> 0) Or Not ((PID = &H8030&) Or (PID = &H8031&)) Then
        DetectForm.Show vbModal, Me
        
        If DetectForm.getIndex <> -1 Then
            DeviceIndex = DetectForm.getIndex()
        Else
            Unload Me
            Exit Sub
        End If
    End If
    
   For count = 0 To 3
        relayImage(count).Picture = openImage.Picture
        inputImage(count).Picture = lowImage.Picture
   Next count
   
   outData = &HF
   
   DIO_WriteAll DeviceIndex, outData
   
   Timer1.Enabled = True
   

End Sub

Private Sub relayImage_Click(Index As Integer)

    ' Just set flag and new data bit
    Dim compare As Integer

    update = True
    
    compare = 2 ^ Index
    outData = outData Xor compare
    
End Sub


Private Sub Timer1_Timer()

    Dim indata As Integer
    Dim count As Integer

    ' Write data if pending:
    If update = True Then
        DIO_WriteAll DeviceIndex, outData
    End If
   
    Dim oDIOData As Integer
    Dim Changes As Integer

    oDIOData = outData
    
    'Read current Relay states and Isolated Input data:
    DIO_ReadAll DeviceIndex, indata
    
    Changes = indata Xor oDIOData
     
    If update = True Then
        Changes = &HFFFF
        update = False
    End If
        
    Dim compare As Integer
    Dim shiftVal As Long
    Dim nNum As Long
        
    shiftVal = &H100
    nNum = 0
        
    'Read back relays for display
    For count = 0 To 3
        compare = 2 ^ count
        If (indata And compare) Then
            relayImage(count).Picture = openImage.Picture
        Else
            relayImage(count).Picture = closedImage.Picture
        End If
    Next count
    
    'Read back isolated inputs for display
    For count = 0 To 3

        nNum = ShiftLeft(shiftVal, count)
        
        If (indata And nNum) Then
            inputImage(count).Picture = lowImage.Picture
        Else
            inputImage(count).Picture = highImage.Picture
        End If
    Next count
        
End Sub


' Shift to the left of the specified number of times
'
' NOTE: requires Power2()

Function ShiftLeft(ByVal Value As Long, ByVal times As Long) As Long
    ' we need to create a mask of 1's corresponding to the
    ' times in VALUE that will be retained in the result
    Dim mask As Long, signBit As Long
    
    ' return zero if too many times
    If times >= 32 Then Exit Function
    ' return the value if zero times
    If times = 0 Then ShiftLeft = Value: Exit Function
    
    ' this extracts the bit in Value that will become the sign bit
    mask = Power2(31 - times)
    ' this calculates the sign bit of the result
    signBit = CBool(Value And mask) And &H80000000
    ' this clears all the most significant times,
    ' that would be lost anyway, and also clears the sign bit
    Value = Value And (mask - 1)
    ' do the shift to the left, without risking an overflow
    ' and then add the sign bit
    ShiftLeft = (Value * Power2(times)) Or signBit
End Function

' Shift to the right of the specified number of times
'
' NOTE: requires Power2()

Function ShiftRight(ByVal Value As Long, ByVal times As Long) As Long
    ' we need to create a mask of 1's corresponding to the
    ' digits in VALUE that will be retained in the result
    Dim mask As Long, signBit As Long
    
    ' return zero if too many times
    If times >= 32 Then Exit Function
    ' return the value if zero times
    If times = 0 Then ShiftRight = Value: Exit Function
    
    ' evaluate the sign bit in advance
    signBit = (Value < 0) And Power2(31 - times)
    ' create a mask with 1's for the digits that will be preserved
    If times < 31 Then
        ' if times=31 then the mask is zero
        mask = Not (Power2(times) - 1)
    End If
    ' clear all the digits that will be discarded, and
    ' also clear the sign bit
    Value = (Value And &H7FFFFFFF) And mask
    ' do the shift, without any problem, and add the sign bit
    ShiftRight = (Value \ Power2(times)) Or signBit
End Function

' Raise 2 to a power
' the exponent must be in the range [0,31]

Function Power2(ByVal exponent As Long) As Long
    Static res(0 To 31) As Long
    Dim I As Long
    
    ' rule out errors
    If exponent < 0 Or exponent > 31 Then Err.Raise 5
    
    ' initialize the array at the first call
    If res(0) = 0 Then
        res(0) = 1
        For I = 1 To 30
            res(I) = res(I - 1) * 2
        Next
        ' this is a special case
        res(31) = &H80000000
    End If
    
    ' return the result
    Power2 = res(exponent)
        
End Function
